{

gROOT->Reset();
//=========================================================

gROOT->SetStyle("Plain");
// Turn off all borders
gStyle->SetCanvasBorderMode(0);
gStyle->SetFrameBorderMode(0);
gStyle->SetPadBorderMode(0);
gStyle->SetDrawBorder(0);
gStyle->SetCanvasBorderSize(0);
gStyle->SetFrameBorderSize(0);
gStyle->SetPadBorderSize(0);
gStyle->SetTitleBorderSize(1);

gStyle->SetNdivisions(505,"xyz");

gStyle->SetLabelSize(0.06,"xyz");
gStyle->SetLabelSize(0.06,"y");
gStyle->SetLabelSize(0.08,"x");
gStyle->SetLabelOffset(0.01,"x");
gStyle->SetLabelOffset(0.01,"y");
gStyle->SetTickLength(0.09);
gStyle->SetTitleColor(2,"xyz");
gStyle->SetTitleOffset(1.3,"y");

gStyle->SetTitleX(0.); gStyle->SetTitleY(1.);
gStyle->SetTitleW(0.98); gStyle->SetTitleH(0.08);
gStyle->SetOptTitle(0);

gStyle->SetStatX(0.90); gStyle->SetStatY(0.90);
gStyle->SetStatW(0.20); gStyle->SetStatH(0.15);

gStyle->SetOptFit(11);
gStyle->SetOptStat(1111);

gStyle->SetPadGridX(0);
gStyle->SetPadGridY(0);

//====================================================================
char tmpchr[200];
char specialname[100];
char comments[100];
char name[100];
sprintf(specialname,"INL512x100");
sprintf(comments,"512 bins INL x100");

sprintf(name,"inlstudy_%s.root",specialname);
cout<<"open "<<name<<endl;

  TCanvas *c1 = new TCanvas("c1", "c1",0,0,850,750);
  c1->Divide(1,2,0.01,0.01);c1->SetFillColor(0);

  TFile f1("inlstudy_normal.root");
  TFile f2(name);

  TLatex* tex;

  c1->cd(1);
  gPad->SetGridy(1);
  TLegend *leg1 = new TLegend(0.1,0.6,0.3,0.90);leg1->SetBorderSize(1);leg1->SetFillColor(0);
  f1.cd();

  Avesigma_vs_chan->SetMarkerStyle(5);
  Avesigma_vs_chan->SetMarkerColor(2);
  Avesigma_vs_chan->SetMarkerSize(0.7);
  Avesigma_vs_chan->SetAxisRange(10,35,"Y");
  Avesigma_vs_chan->Draw();;
  leg1->AddEntry(Avesigma_vs_chan,"normal INL","lp");
  f2.cd();
  Avesigma_vs_chan->SetMarkerStyle(2);
  Avesigma_vs_chan->SetMarkerColor(4);
  Avesigma_vs_chan->SetMarkerSize(0.7);
  Avesigma_vs_chan->Draw("sames");
  leg1->AddEntry(Avesigma_vs_chan,comments,"lp");
  
  tex = new TLatex(-15.,24.,"Ave RMS (ps)");
  tex->SetTextColor(2);
  tex->SetTextAngle(90);tex->SetLineWidth(2);
  tex->Draw();
  tex = new TLatex(380,7.50,"# CHAN");
  tex->SetTextColor(2);
  tex->SetTextSize(0.06);tex->SetLineWidth(2);
  tex->Draw();
  //----
   leg1->Draw();
  //=======================================================================
  c1->cd(2);

  gPad->SetGridy(1);
  TLegend *leg2 = new TLegend(0.1,0.6,0.3,0.90);leg2->SetBorderSize(1);leg2->SetFillColor(0);
  f1.cd();
  allchan_ave_sigma->SetLineColor(2);
  allchan_ave_sigma->SetLineWidth(2);
  allchan_ave_sigma->SetAxisRange(5,40,"X");
  allchan_ave_sigma->Draw();;
  leg2->AddEntry(allchan_ave_sigma,"normal INL","lp");
  f2.cd();
  allchan_ave_sigma->SetLineColor(4);
  allchan_ave_sigma->SetLineWidth(2);
  allchan_ave_sigma->SetAxisRange(5,40,"X");
  allchan_ave_sigma->Draw("sames");;

  tex = new TLatex(34,-3.80,"Ave RMS (ps)");
  tex->SetTextColor(2);
  tex->SetTextSize(0.05);tex->SetLineWidth(2);
  tex->Draw();
  leg2->AddEntry(allchan_ave_sigma,comments,"lp"); 
  leg2->Draw();

  //============================================================================
  sprintf(tmpchr,"inlstudy_%s.gif",specialname);
  c1->Print(tmpchr);
  sprintf(tmpchr,"c1->Print(\"%s\");",tmpchr);
cout<<tmpchr<<endl;
  //

}
