{
#include "Riostream.h"
 
#include "TCanvas.h"
#include "TFile.h"
#include "TDirectory.h"
#include "TLegend.h"

using namespace std;

gROOT->Reset();
gSystem->ProcessEvents();

char dat[255],label[255],title[255],batchtitle[255],tmpchr[255];

Double_t x,y;
Int_t i,z,b,j,k,l,numboards,numtests;

cout<<"Number of boards to compare=";
cin>>numboards;

while(1){
cout<<"Number of tests to compare=";
cin>>numtests;
if(numtests>1) break;
cout<<"Must compare > 1 test"<<endl;
}

char boards[numtests][numboards][255],boardnumb[numboards][255],testnumb[numtests][255];

for(j=1; j<=numboards; j++) {
cout<<"Board "<<j<<" number=tdig-ser";
cin>>boardnumb[j-1];
}
for(i=1; i<=numtests; i++) {
cout<<"Board extensions (test #"<<i<<") (type 'zzz' for no extension)=";
cin>>testnumb[i-1];
if(testnumb[i-1][0]=='z') {
if(testnumb[i-1][1]=='z') {
if(testnumb[i-1][2]=='z') {
sprintf(testnumb[i-1],"");
}}}
for(j=1;j<=numboards;j++) {
sprintf(boards[i-1][j-1],"tdig-ser%s%s",boardnumb[j-1],testnumb[i-1]);
}}

cout<<"Batch title (no spaces)=";
cin>>batchtitle;

cout<<"Making dir: "<<batchtitle<<endl;
sprintf(label,"mkdir -p %s",batchtitle);
gSystem->Exec(label);

cout<<"Making dir: "<<batchtitle<<"/gif"<<endl;
sprintf(label,"mkdir -p %s/gif",batchtitle);
gSystem->Exec(label);

cout<<"Making dir: "<<batchtitle<<"/data"<<endl;
sprintf(label,"mkdir -p %s/data",batchtitle);
gSystem->Exec(label);

cout<<"Downloading data..."<<endl;
sprintf(label, "%s/data",batchtitle);
gSystem->ChangeDirectory(label);
for(j=1; j<=numboards; j++) {
for(i=1; i<=numtests; i++) {
sprintf(label,"cp ../../../../result/%s/inl/%s.inl.tar .",boards[i-1][j-1],boards[i-1][j-1]);
gSystem->Exec(label);
}}
cout<<"Download complete!"<<endl<<"Extracting data..."<<endl;
for(j=1; j<=numboards; j++) {
for(i=1; i<=numtests; i++) {
sprintf(label, "tar -xf %s.inl.tar",boards[i-1][j-1]);
gSystem->Exec(label);
}}
gSystem->ChangeDirectory("../..");
cout<<"Extraction complete!"<<endl<<"Generating plots..."<<endl;

TH1F* h7[numtests][numboards][3][8][3];
TH1F* h8[numtests][2];
TImage *img = TImage::Create();
TCanvas *c1;
sprintf(label,"%s/%s.root",batchtitle,batchtitle);
TFile rootf(label,"recreate");

z=1;
for(Int_t a=1; a<(numtests+1); a++) {

j=1;
if(a>1) {
   sprintf(title,"Comparing %s to %s %s Summary Mean",testnumb[a-2],testnumb[a-1],batchtitle);
   h8[a-2][0] = new TH1F(title,title,24*numboards,1,24*numboards+1);
   sprintf(title,"Comparing %s to %s %s Summary STD",testnumb[a-2],testnumb[a-1],batchtitle);
   h8[a-2][1] = new TH1F(title,title,24*numboards,1,24*numboards+1);
}
for(Int_t e=0; e<numboards; e++) {
for(Int_t c=0; c<3; c++) {
for(Int_t d=0; d<8; d++) {

   sprintf(title, "%s.tdc%i.ch%i.inl",boards[a-1][e],c,d);
   h7[a-1][e][c][d][0] = new TH1F(title,"",1024,1,1025);
   sprintf(title, "%s.tdc%i.ch%i.diff",boards[a-1][e],c,d);
   h7[a-1][e][c][d][1] = new TH1F(title,"",1024,1,1025);
   sprintf(title, "%s.tdc%i.ch%i.diff.sand",boards[a-1][e],c,d);
   h7[a-1][e][c][d][2] = new TH1F(title,"",400,-2.5,2.5);

   sprintf(dat, "%s/data/%s.tdc%i.ch%i.inl",batchtitle,boards[a-1][e],c,d);
   ifstream f(dat);
   
   i=0;
   while (1) {
      f >> x >> y;
      if (!f.good()) break;
      h7[a-1][e][c][d][0]->Fill(i,y);
      if (a>1) {
         h7[a-2][e][c][d][1]->Fill(i,y-h7[a-2][e][c][d][0]->GetBinContent(i));
         h7[a-2][e][c][d][2]->Fill(h7[a-2][e][c][d][1]->GetBinContent(i),1);
      }
      i++;
   }
if (a>1) {
   
   gStyle->SetOptStat("");
   //comment out from here...
   
   c1 = new TCanvas("c1","",1330,900);
   c1.Divide(1,2);
   sprintf(title,"Comparing %s to %s: tdc%i.ch%i",boards[a-2][e],boards[a-1][e],c,d);
   c1->SetTitle(title);
   
   c1.cd(1);

   h7[a-2][e][c][d][0]->SetLineColor(2);
   h7[a-2][e][c][d][0]->GetXaxis()->SetTitle("Bins");
   h7[a-2][e][c][d][0]->GetYaxis()->SetTitle("INL corr (bin)");
   h7[a-2][e][c][d][0]->Draw();
   
   h7[a-1][e][c][d][0]->SetLineColor(4);
   h7[a-1][e][c][d][0]->Draw("same");

   TLegend *legend = new TLegend(.8,.8,.9,.9);
   legend->AddEntry(h7[a-2][e][c][d][0],"Run 1","l");
   legend->AddEntry(h7[a-1][e][c][d][0],"Run 2","l");
   legend->Draw();

   c1.cd(2);
   
   h7[a-2][e][c][d][1]->SetLineColor(6);
   h7[a-2][e][c][d][1]->GetXaxis()->SetTitle("Bins");
   h7[a-2][e][c][d][1]->GetYaxis()->SetTitle("INL corr difference (bin)");
   h7[a-2][e][c][d][1]->Draw();
   
   c1.cd(0);
   c1->Update();
   
   img->FromPad(c1);
   sprintf(title,"%s/gif/Comparing_%s_to_%s_tdc%i.ch%i.gif",batchtitle,boards[a-2][e],boards[a-1][e],c,d);
   img->WriteImage(title);
   
   c1.cd(1);
   
   h7[a-2][e][c][d][1]->Draw();
   
   c1.cd(2);
   
   h7[a-2][e][c][d][2]->SetLineColor(4);
   h7[a-2][e][c][d][2]->GetXaxis()->SetTitle("Bins");
   h7[a-2][e][c][d][2]->GetYaxis()->SetTitle("Counts");
   h7[a-2][e][c][d][2]->Draw();
   
   sprintf(title,"Sand comparing %s to %s: tdc%i.ch%i",boards[a-2][e],boards[a-1][e],c,d);
   c1->SetTitle(title);
   c1.cd(0);
   c1->Update();
   
   img->FromPad(c1);
   sprintf(title,"%s/gif/Sand_comparing_%s_to_%s_tdc%i.ch%i.gif",batchtitle,boards[a-2][e],boards[a-1][e],c,d);
   img->WriteImage(title);

   //...to here for just the summarys*/
   
   h8[a-2][0]->SetLineColor(a);
   h8[a-2][1]->SetLineColor(a);
   h8[a-2][0]->Fill(j,h7[a-2][e][c][d][2]->GetMean());
   h8[a-2][1]->Fill(j,h7[a-2][e][c][d][2]->GetRMS());

   if(a==2) {
      if(c==0 & d==0) {
         sprintf(title, "%s",boardnumb[e]);
//         sprintf(tmpchr,"%s vs %s",boards[a-2][e],boards[a-1][e]);
//         leg->AddEntry(h8[a-2],tmpchr,"l"); cout<<"added "<<tmpchr<<endl;
      }
      else {
         sprintf(title, "%i,%i",c,d);
      }
      h8[0][0]->GetXaxis()->SetBinLabel(j,title);
      h8[0][1]->GetXaxis()->SetBinLabel(j,title);
   }
   
   j++;
}}}}}
cout<<"Generating summary plot..."<<endl;

TLegend *leg = new TLegend(.87,.8,1,1);
for(int a=0;a<numtests-1;a++){
	sprintf(tmpchr,"%s vs %s",testnumb[a],testnumb[a+1]);
	leg->AddEntry(h8[a][0],tmpchr,"l");
}

c1 = new TCanvas("c1","",1330,900);
c1.Divide(1,2);

c1.cd(1);
sprintf(title, "Comparing %s to %s: mean", testnumb[0], testnumb[1]);
h8[0][0]->SetTitle(title);
h8[0][0]->GetXaxis()->SetTitle("Board Number/TDC,CH");
h8[0][0]->GetYaxis()->SetTitle("Mean of differences");
h8[0][0]->GetYaxis()->SetRangeUser(-1.5,1.5);
h8[0][0]->Draw();
h8[0][0]->Write();
leg->Draw();

c1.cd(2);
sprintf(title, "Comparing %s to %s: STD", testnumb[0], testnumb[1]);
h8[0][1]->SetTitle(title);
h8[0][1]->GetXaxis()->SetTitle("Board Number/TDC,CH");
h8[0][1]->GetYaxis()->SetTitle("STD of differences");
h8[0][1]->GetYaxis()->SetRangeUser(0,1);
h8[0][1]->Draw();
h8[0][1]->Write();
//leg->Draw();

for(a=1; a<numtests-1; a++) {
   c1.cd(1);
   sprintf(title, "Comparing %s to %s: mean", testnumb[a], testnumb[a+1]);
   h8[a][0]->SetTitle(title);
   h8[a][0]->Draw("same");
   h8[a][0]->Write();
   c1.cd(2);
   sprintf(title, "Comparing %s to %s: STD", testnumb[a], testnumb[a+1]);
   h8[a][1]->SetTitle(title);
   h8[a][1]->Draw("same");
   h8[a][1]->Write();
}

h8[0][0]->SetTitle(batchtitle);
h8[0][1]->SetTitle("");
c1.cd(0);
img->FromPad(c1);
sprintf(title,"%s/gif/INL_Comparison_summary.gif",batchtitle);
img->WriteImage(title);

cout<<"Cleaning up..."<<endl;
rootf.Close();
delete c1;
sprintf(label,"rm -rf %s/data",batchtitle);
gSystem->Exec(label);
cout<<"Finished!"<<endl;
}



